# copied from libtool.m4 - Configure libtool for the host system. -*-Autoconf-*-
# 
# Copyright 1996, 1997, 1998, 1999, 2000, 2001
# Free Software Foundation, Inc.
# Originally by Gordon Matzigkeit <gord@gnu.ai.mit.edu>, 1996
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# As a special exception to the GNU General Public License, if you
# distribute this file as part of a program that contains a
# configuration script generated by Autoconf, you may include it under
# the same distribution terms that you use for the rest of that program.

AC_DEFUN([AX_SAGA_CHECK_LIBDL],
[
  LIBADD_DL=

  AC_SUBST(LIBADD_DL)
  AC_LANG_PUSH([C])

  AC_CHECK_FUNC([shl_load],
    [AC_DEFINE([HAVE_SHL_LOAD], [1],
               [Define if you have the shl_load function.])],
       [AC_CHECK_LIB([dld], [shl_load],
          [AC_DEFINE([HAVE_SHL_LOAD], [1], [Define if you have the shl_load function.])
              LIBADD_DL="$LIBADD_DL -ldld"],
             [AC_CHECK_LIB([dl], [dlopen],
                [AC_DEFINE([HAVE_LIBDL], [1],
                           [Define if you have the libdl library or equivalent.])
                    LIBADD_DL="-ldl" libltdl_cv_lib_dl_dlopen="yes"],
                   [AC_TRY_LINK([#if HAVE_DLFCN_H
                                 #  include <dlfcn.h>
                                 #endif
                                ],[dlopen(0, 0);],
                      [AC_DEFINE([HAVE_LIBDL], [1],
                                 [Define if you have the libdl library or equivalent.]) 
                          libltdl_cv_func_dlopen="yes"],
                         [AC_CHECK_LIB([svld], [dlopen],
                            [AC_DEFINE([HAVE_LIBDL], [1],
                                       [Define if you have the libdl library or equivalent.])
                                LIBADD_DL="-lsvld" libltdl_cv_func_dlopen="yes"],
                               [AC_CHECK_LIB([dld], [dld_link],
                                  [AC_DEFINE([HAVE_DLD], [1],
                                             [Define if you have the GNU dld library.])
                                      LIBADD_DL="$LIBADD_DL -ldld"],
                                     [AC_CHECK_FUNC([_dyld_func_lookup],
                                        [AC_DEFINE([HAVE_DYLD], [1],
                                            [Define if you have the _dyld_func_lookup function.])])
                               ])
                         ])
                   ])
             ])
       ])
  ])

  if test "x$libltdl_cv_func_dlopen"   = "xyes" || \
     test "x$libltdl_cv_lib_dl_dlopen" = "xyes" ; then

    lt_save_LIBS="$LIBS"
    LIBS="$LIBS $LIBADD_DL"
    
    AC_CHECK_FUNCS([dlerror])
    LIBS="$lt_save_LIBS"

  fi

  AC_LANG_POP

  export LIBADD_DL

])


