#  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
# 
#  Distributed under the Boost Software License, Version 1.0. (See accompanying
#  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

ifndef SAGA_MK_INC_CONF_C
       SAGA_MK_INC_CONF_C = yes

###########################################################
#
# version
#
SAGA_VERSION               = 1.6.1
SAGA_VERSION_FULL          = 0x010601
SAGA_VERSION_MAJOR         = 1
SAGA_VERSION_MINOR         = 6
SAGA_VERSION_SUBMINOR      = 1
SAGA_VERSION_DATE          = 20120426
#
###########################################################

###########################################################
#
# paths
#
ifndef SAGA_LOCATION
 SAGA_LOCATION             = /usr
endif

SAGA_CONFIGURE_OK          = yes

SAGA_BIN_ROOT              = /usr/bin
SAGA_SHS_ROOT              = /usr/bin
SAGA_LIB_ROOT              = /usr/lib64
SAGA_HDR_ROOT              = /usr/include
SAGA_DAT_ROOT              = /usr/share/saga
SAGA_INI_ROOT              = /usr/share/saga
SAGA_MAN_ROOT              = /usr/share/man
SAGA_MAK_ROOT              = /usr/share/saga/make
SAGA_M4_ROOT               = /usr/share/saga/config

SAGA_EXT_ROOT              = $(SAGA_ROOT)/external

ifdef SAGA_ROOT
SAGA_CONFDIR               = /home/condor/execute/dir_3077/userdir/SAGA.lsu-cpp.engine/config/
endif
#
###########################################################

###########################################################
#
# Tools
#
BC                         = /usr/bin/bc
CP                         = /bin/cp -f
LN                         = /bin/ln -s
LS                         = /bin/ls
MV                         = /bin/mv -f
RM                         = /bin/rm -f
SH                         = /bin/sh
TR                         = /usr/bin/tr
AWK                        = /bin/awk
CAT                        = /bin/cat
CUT                        = /bin/cut
ENV                        = /bin/env
RPM                        = /bin/rpm
RPMBUILD                   = /usr/bin/rpmbuild
PWD                        = /bin/pwd
SED                        = /bin/sed
SCP                        = /usr/bin/scp
SSH                        = /usr/bin/ssh
TAR                        = /bin/tar
DATE                       = /bin/date
DPKG                       = 
GREP                       = /bin/grep
GZIP                       = /bin/gzip
ECHO                       = /bin/echo
FIND                       = /usr/bin/find
GZIP                       = /bin/gzip
SORT                       = /bin/sort
TEST                       = /usr/bin/test
TRUE                       = /bin/true
UNIQ                       = /usr/bin/uniq
EGREP                      = /bin/grep -E
MKDIR                      = /bin/mkdir -p
TOUCH                      = /bin/touch
FALSE                      = /bin/false
SLEEP                      = /bin/sleep
XARGS                      = /usr/bin/xargs
PDFLATEX                   = 
BIBTEX                     = 
HTLATEX                    = 
DOXYGEN                    = 
EPYDOC                     = 
DEVNULL                    = /dev/null

MAKE                      += --no-print-directory
#
############################################################

###########################################################
#
# Compiler
#
SAGA_CPP                   = g++ -E
SAGA_CPPFLAGS             += -E
SAGA_CPPINCS              += 
SAGA_CPPINCS_SYS          += 

SAGA_CC                    = gcc
ifneq "$(SAGA_DEBUG_MAKE)" "yes"
SAGA_CCFLAGS              += -g -O2
else
SAGA_CCFLAGS              += $(filter-out -O%,-g -O2)
endif

SAGA_CXX                   = g++
ifneq "$(SAGA_DEBUG_MAKE)" "yes"
SAGA_CXXFLAGS             += -g 
else
SAGA_CXXFLAGS             += $(filter-out -O%,-g )
endif

SAGA_GCC_VISIBILITY        = -fvisibility=default

SAGA_LD                    = g++
SAGA_LD_BIN                = g++
SAGA_LD_LIB                = g++
SAGA_LDFLAGS              +=  -L/usr/lib/ -lssl
SAGA_LDFLAGS_SYS          += -Wl,--no-as-needed

SAGA_LDFLAGS_READLINE      = 

SAGA_AR                    = /usr/bin/ar
SAGA_ARFLAGS              += rcs

SAGA_LDFLAGS_PROFILER      = 
SAGA_CCACHE                = 

SAGA_OSTYPE                = SAGA_LINUX
SAGA_ARCH                  = x86_64
SAGA_DEB_ARCH              = 
SAGA_RPM_ARCH              = x86_64

SAGA_BUILD_LIB_STATIC      = yes
SAGA_BUILD_LIB_DYNAMIC     = yes

# always add libdl
SAGA_LDFLAGS_SYS          += -ldl

# honor user provided flags
SAGA_CPPINCS              += $(SAGA_INC_FLAGS)
SAGA_CPPINCS_SYS          += $(SAGA_INC_FLAGS_SYS)
SAGA_ARFLAGS_SYS          += $(SAGA_AR_FLAGS)

#
###########################################################



###########################################################
#
# external dependencies (non-boost)
#
SAGA_HAVE_SOCI                = no
SAGA_HAVE_SOCI_SQLITE3        = 
SAGA_HAVE_SOCI_POSTGRESQL     = 
SAGA_HAVE_SOCI_ORACLE         = 
SAGA_HAVE_SOCI_MYSQL          = 
SAGA_HAVE_SOCI_ODBC           = 
SAGA_HAVE_SOCI_FIREBIRD       = 

SAGA_HAVE_INTERNAL_SOCI       = no

SAGA_HAVE_SQLITE3             = no
HAVE_SQLITE3_DTOR_TYPE        = 0

SAGA_HAVE_POSTGRESQL          = no

SAGA_HAVE_XMLRPC              = no
SAGA_HAVE_OPENSSL             = yes
#
###########################################################

###########################################################
#
# external package dependencies
#
SAGA_DEP_FILES                = @SAGA_DEP_FILES@
#
###########################################################

###########################################################
#
# MacOS X specific compiler settings
#
ifeq "$(SAGA_OSTYPE)" "SAGA_APPLE"

  SAGA_LEXT                = dylib
  SAGA_AEXT                = a

ifneq "$(SAGA_DEBUG_MAKE)" "yes"
# SAGA_CXXFLAGS           += -Os
endif

  SAGA_CXXFLAGS           += -pipe -Wall -ansi -std=c++98
  SAGA_CXXFLAGS           += -Wno-trigraphs
  SAGA_CXXFLAGS_INT       += -fvisibility-inlines-hidden
  SAGA_LD_LIB             += -dynamiclib

  SAGA_CPPDEFS            += -D_FILE_OFFSET_BITS=64

endif
#
###########################################################

###########################################################
#
# IBM AIX 5 specific compiler settings
#
ifeq "$(SAGA_OSTYPE)" "SAGA_AIX"

  SAGA_LEXT                = so
  SAGA_AEXT                = a

  ifeq "$(findstring gcc, $(SAGA_CC))" "gcc"  
    SAGA_LD_LIB           += -shared
    SAGA_LDFLAGS_SYS      += -pthread -Wl,-G -Wl,-brtl 
    SAGA_LDFLAGS_SYS      += -Wl,-binitfini:_GLOBAL__DI:_GLOBAL__DD
  endif
   
  ifeq "$(findstring xlc, $(SAGA_CC))" "xlc"  
    SAGA_LDFLAGS_SYS      += -L/usr/lib/threads -G -brtl -bnoentry -lpthread -lc_r
    SAGA_CPPDEFS          += -D_THREAD_SAFE
    SAGA_CXXFLAGS         += -bnoentry
    SAGA_CCFLAGS          += -bnoentry
  endif
   
endif
#
###########################################################

###########################################################
#
# SunOS (Solaris)  specific compiler settings
#
ifeq "$(SAGA_OSTYPE)" "SAGA_SunOS"

  SAGA_LEXT                = so
  SAGA_AEXT                = a

  SAGA_LD_LIB           += -shared
  SAGA_LDFLAGS_SYS      += -pthread -lsocket

  ifeq "$(findstring gcc, $(SAGA_CC))" "gcc"
    SAGA_CCFLAGS          += -pipe -fPIC
    SAGA_CCFLAGS          += -Wall -Wno-unknown-pragmas -ansi -std=c99
    SAGA_CXXFLAGS         += -fno-strict-aliasing -Wall -Wno-unknown-pragmas
  endif

  ifeq "$(findstring g++, $(SAGA_CXX))" "g++"
    SAGA_CXXFLAGS         += -pipe -fPIC
    SAGA_CXXFLAGS         += $(SAGA_GCC_VISIBILITY) -Wall -Wno-unknown-pragmas
    SAGA_CXXFLAGS         += -fno-strict-aliasing -ansi -std=c++98
  endif

endif
#
###########################################################


###########################################################
# 
# Linux specific compiler settings
#
ifeq "$(SAGA_OSTYPE)" "SAGA_LINUX"

  SAGA_LEXT                = so
  SAGA_AEXT                = a

  SAGA_LD_LIB             += -shared

  SAGA_CPPDEFS            += -D_FILE_OFFSET_BITS=64

  ifeq "$(findstring gcc, $(SAGA_CC))" "gcc"
    SAGA_CCFLAGS          += -pipe -fPIC
    SAGA_CCFLAGS          += -Wall -Wno-unknown-pragmas -ansi -std=c99
    SAGA_CXXFLAGS         += -fno-strict-aliasing -Wall -Wno-unknown-pragmas
  endif

  ifeq "$(findstring g++, $(SAGA_CXX))" "g++"
    SAGA_CXXFLAGS         += -pipe -fPIC
    SAGA_CXXFLAGS         += $(SAGA_GCC_VISIBILITY) -Wall -Wno-unknown-pragmas
    SAGA_CXXFLAGS         += -fno-strict-aliasing -ansi -std=c++98
  endif

  ifeq "$(findstring g++, $(SAGA_LD))" "g++"
    SAGA_USE_SONAME        = yes
  endif

  ifeq "$(findstring icc, $(SAGA_CC))" "icc"
    SAGA_CCFLAGS          += -w1 -fpic -wd1125  
  endif

  ifeq "$(findstring icpc, $(SAGA_CXX))" "icpc"
    SAGA_CXXFLAGS         += -w1 -fpic -wd1125
  endif

  ifeq "$(findstring icpc, $(SAGA_LD))" "icpc"
    SAGA_LDFLAGS_SYS      += -static-libcxa -cxxlib-icc
  endif


endif
#
###########################################################

###########################################################
#
# well, we always need boost
#
ifeq "$(filter clean distclean confclean,$(MAKECMDGOALS))" ""
  ifdef SAGA_ROOT
    include $(SAGA_ROOT)/make/saga.config.boost.c.mk
  else
    include $(SAGA_LOCATION)/share/saga/make/saga.config.boost.c.mk
  endif
endif
#
###########################################################


###########################################################
#
# we also load any configuration checks we may know about
#
ifeq "$(filter clean distclean confclean,$(MAKECMDGOALS))" ""
  ifdef SAGA_ROOT
    include $(SAGA_ROOT)/make/saga.config.check.c.mk
  else
    include $(SAGA_LOCATION)/share/saga/make/saga.config.check.c.mk
  endif
endif
#
###########################################################

endif # guard

